%This Example for using users m-function Optimization_subroutine.m was created automatically by PSG Toolbox.

%Function description:

%minimize
%linear(matrix_ruszcz_obj)
%Constraint: <= parameter_bound
%pr_pen(parameter_alpha, recourse(matrix_xfirst_ruszcz, matrix_subproblem_ruszcz, matrix_of_scenarios_ruszcz_700redu))
%Box: >= parameter_bound_1
%
%
%Input variables:
%
%Inputs                                     PSG Type    PSG Object                            Location in Problem Statement                                                                                            Class
%matrix_ruszcz_obj_data                     data        matrix_ruszcz_obj                     linear(matrix_ruszcz_obj)                                                                                                double
%matrix_ruszcz_obj_vars                     vars        matrix_ruszcz_obj                     linear(matrix_ruszcz_obj)                                                                                                cell
%matrix_xfirst_ruszcz_data                  data        matrix_xfirst_ruszcz                  pr_pen(parameter_alpha, recourse(matrix_xfirst_ruszcz, matrix_subproblem_ruszcz, matrix_of_scenarios_ruszcz_700redu))    double
%matrix_xfirst_ruszcz_vars                  vars        matrix_xfirst_ruszcz                  pr_pen(parameter_alpha, recourse(matrix_xfirst_ruszcz, matrix_subproblem_ruszcz, matrix_of_scenarios_ruszcz_700redu))    cell
%matrix_subproblem_ruszcz_benchmark         bench       matrix_subproblem_ruszcz              pr_pen(parameter_alpha, recourse(matrix_xfirst_ruszcz, matrix_subproblem_ruszcz, matrix_of_scenarios_ruszcz_700redu))    double
%matrix_subproblem_ruszcz_data              data        matrix_subproblem_ruszcz              pr_pen(parameter_alpha, recourse(matrix_xfirst_ruszcz, matrix_subproblem_ruszcz, matrix_of_scenarios_ruszcz_700redu))    double
%matrix_subproblem_ruszcz_vars              vars        matrix_subproblem_ruszcz              pr_pen(parameter_alpha, recourse(matrix_xfirst_ruszcz, matrix_subproblem_ruszcz, matrix_of_scenarios_ruszcz_700redu))    cell
%matrix_of_scenarios_ruszcz_700redu_data    data        matrix_of_scenarios_ruszcz_700redu    pr_pen(parameter_alpha, recourse(matrix_xfirst_ruszcz, matrix_subproblem_ruszcz, matrix_of_scenarios_ruszcz_700redu))    double
%matrix_of_scenarios_ruszcz_700redu_vars    vars        matrix_of_scenarios_ruszcz_700redu    pr_pen(parameter_alpha, recourse(matrix_xfirst_ruszcz, matrix_subproblem_ruszcz, matrix_of_scenarios_ruszcz_700redu))    cell
%parameter_bound_data                       data        parameter_bound                       Constraint: <= parameter_bound                                                                                           double
%parameter_alpha_data                       data        parameter_alpha                       pr_pen(parameter_alpha, recourse(matrix_xfirst_ruszcz, matrix_subproblem_ruszcz, matrix_of_scenarios_ruszcz_700redu))    double
%parameter_bound_1_data                     data        parameter_bound_1                     Box: >= parameter_bound_1                                                                                                double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('D:\American Optimal Decisions\PSG\MATLAB_Stan\All\Stochastic Multicommodity Network Flow Problem\data_problem_2st_multicomm_short\Optimization_subroutine_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function Optimization_subroutine:

[solution_str,outargstruc_arr] = Optimization_subroutine(matrix_ruszcz_obj_data,matrix_ruszcz_obj_vars,matrix_xfirst_ruszcz_data,matrix_xfirst_ruszcz_vars,matrix_subproblem_ruszcz_benchmark,matrix_subproblem_ruszcz_data,matrix_subproblem_ruszcz_vars,matrix_of_scenarios_ruszcz_700redu_data,matrix_of_scenarios_ruszcz_700redu_vars,parameter_bound_data,parameter_alpha_data,parameter_bound_1_data);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data);

%Extract structure containing PSG solution reports:
output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

disp(' ');
disp('Structure with PSG solution = ');
disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
